> ## Documentation Index
> Fetch the complete documentation index at: https://developers.dwolla.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List events

> Returns a paginated list of events representing state changes to resources in your Dwolla application. Events track actions on customers, transfers, funding sources, and other resources, sorted by creation date (newest first). Events are retained for 30 days and are essential for webhook notifications and system activity monitoring.



## OpenAPI

````yaml get /events
openapi: 3.1.0
info:
  title: Dwolla API
  description: Dwolla API Documentation
  contact:
    name: Dwolla Developer Relations Team
    url: https://developers.dwolla.com
    email: api@dwolla.com
  version: '2.0'
  termsOfService: https://www.dwolla.com/legal/tos/
  license:
    name: MIT
    url: https://github.com/Dwolla/dwolla-openapi/blob/master/LICENSE
servers:
  - url: https://api.dwolla.com
    description: Production server
  - url: https://api-sandbox.dwolla.com
    description: Sandbox server
security:
  - clientCredentials: []
tags:
  - name: tokens
    description: Operations related to Application Access Tokens
  - name: root
    description: Root API operations
  - name: accounts
    description: Operations related to Accounts
  - name: customers
    description: Operations related to Customers
  - name: kba
    description: Operations related to Knowledge-Based Authentication
  - name: beneficial owners
    description: Operations related to Beneficial Owners
  - name: documents
    description: Operations related to Documents
  - name: exchanges
    description: Operations related to Exchanges
  - name: exchange sessions
    description: Operations related to Exchange Sessions
  - name: funding sources
    description: Operations related to Funding Sources
  - name: transfers
    description: Operations related to Transfers
  - name: labels
    description: Operations related to Labels
  - name: mass payments
    description: Operations related to Mass Payments
  - name: events
    description: Operations related to Events
  - name: webhook subscriptions
    description: Operations related to Webhook Subscriptions
  - name: webhooks
    description: Operations related to Webhooks
  - name: client tokens
    description: Operations related to Client Tokens
  - name: sandbox simulations
    description: Sandbox-only operations for simulating processing of bank transfers
paths:
  /events:
    get:
      tags:
        - events
      summary: List events
      description: >-
        Returns a paginated list of events representing state changes to
        resources in your Dwolla application. Events track actions on customers,
        transfers, funding sources, and other resources, sorted by creation date
        (newest first). Events are retained for 30 days and are essential for
        webhook notifications and system activity monitoring.
      operationId: listEvents
      parameters:
        - name: limit
          in: query
          description: How many results to return
          required: false
          schema:
            type: integer
        - name: offset
          in: query
          description: How many results to skip
          required: false
          schema:
            type: integer
        - $ref: '#/components/parameters/Accept'
      responses:
        '200':
          description: successful operation
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                $ref: '#/components/schemas/Events'
        '404':
          description: not found
          headers: {}
          content:
            application/vnd.dwolla.v1.hal+json:
              schema:
                $ref: '#/components/schemas/NotFoundError'
      x-codeSamples:
        - lang: bash
          source: >
            GET https://api-sandbox.dwolla.com/events

            Accept: application/vnd.dwolla.v1.hal+json

            Authorization: Bearer
            pBA9fVDBEyYZCEsLf/wKehyh1RTpzjUj5KzIRfDi0wKTii7DqY


            ...


            {
              "_links": {
                "self": {
                  "href": "https://api-sandbox.dwolla.com/events"
                },
                "first": {
                  "href": "https://api-sandbox.dwolla.com/events?limit=25&offset=0"
                },
                "last": {
                  "href": "https://api-sandbox.dwolla.com/events?limit=25&offset=150"
                },
                "next": {
                  "href": "https://api-sandbox.dwolla.com/events?limit=25&offset=25"
                }
              },
              "_embedded": {
                "events": [
                  {
                    "_links": {
                      "self": {
                        "href": "https://api-sandbox.dwolla.com/events/78e57644-56e4-4da2-b743-059479f2e80f"
                      },
                      "resource": {
                        "href": "https://api-sandbox.dwolla.com/transfers/47CFDDB4-1E74-E511-80DB-0AA34A9B2388"
                      },
                      "account": {
                        "href": "https://api-sandbox.dwolla.com/accounts/ca32853c-48fa-40be-ae75-77b37504581b"
                      }
                    },
                    "id": "78e57644-56e4-4da2-b743-059479f2e80f",
                    "created": "2015-10-16T15:58:18.000Z",
                    "topic": "bank_transfer_created",
                    "resourceId": "47CFDDB4-1E74-E511-80DB-0AA34A9B2388"
                  },
                  {
                    "_links": {
                      "self": {
                        "href": "https://api-sandbox.dwolla.com/events/f8e70f48-b7ff-47d0-9d3d-62a099363a76"
                      },
                      "resource": {
                        "href": "https://api-sandbox.dwolla.com/transfers/48CFDDB4-1E74-E511-80DB-0AA34A9B2388"
                      },
                      "account": {
                        "href": "https://api-sandbox.dwolla.com/accounts/ca32853c-48fa-40be-ae75-77b37504581b"
                      }
                    },
                    "id": "f8e70f48-b7ff-47d0-9d3d-62a099363a76",
                    "created": "2015-10-16T15:58:15.000Z",
                    "topic": "transfer_created",
                    "resourceId": "48CFDDB4-1E74-E511-80DB-0AA34A9B2388"
                  },
                  {
                    "_links": {
                      "self": {
                        "href": "https://api-sandbox.dwolla.com/events/9f0167e0-dce6-4a1a-ad26-30015d6f1cc1"
                      },
                      "resource": {
                        "href": "https://api-sandbox.dwolla.com/transfers/08A166BC-1B74-E511-80DB-0AA34A9B2388"
                      },
                      "account": {
                        "href": "https://api-sandbox.dwolla.com/accounts/ca32853c-48fa-40be-ae75-77b37504581b"
                      }
                    },
                    "id": "9f0167e0-dce6-4a1a-ad26-30015d6f1cc1",
                    "created": "2015-10-16T15:37:03.000Z",
                    "topic": "bank_transfer_created",
                    "resourceId": "08A166BC-1B74-E511-80DB-0AA34A9B2388"
                  }
                ]
              },
              "total": 3
            }
        - lang: javascript
          source: |
            // Using dwolla-v2 - https://github.com/Dwolla/dwolla-v2-node
            dwolla.get("events").then((res) => res.body.total); // => 3
        - lang: python
          source: |
            # Using dwollav2 - https://github.com/Dwolla/dwolla-v2-python
            events = app_token.get('events')
            events.body['total'] # => 3
        - lang: php
          source: >
            <?php

            // Using dwollaswagger -
            https://github.com/Dwolla/dwolla-swagger-php

            $eventsApi = new DwollaSwagger\EventsApi($apiClient);


            $events = $eventsApi->events();

            $events->total; # => 3

            ?>
        - lang: ruby
          source: |
            # Using dwolla_v2 - https://github.com/Dwolla/dwolla-v2-ruby
            events = app_token.get "events"
            events.total # => 3
components:
  parameters:
    Accept:
      name: Accept
      in: header
      required: true
      description: >-
        The media type of the response. Must be
        application/vnd.dwolla.v1.hal+json
      schema:
        type: string
        enum:
          - application/vnd.dwolla.v1.hal+json
        default: application/vnd.dwolla.v1.hal+json
  schemas:
    Events:
      title: Events
      type: object
      properties:
        _links:
          type: object
        additionalProperties:
          $ref: '#/components/schemas/HalLink'
        _embedded:
          type: object
          properties:
            events:
              type: array
              items:
                $ref: '#/components/schemas/Event'
        total:
          type: integer
          format: int32
          example: 3
    NotFoundError:
      title: NotFoundError
      description: Error response schema for 404 NotFound
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          example: NotFound
        message:
          type: string
          example: The requested resource was not found.
    HalLink:
      title: HalLink
      type: object
      properties:
        href:
          type: string
          example: https://api.dwolla.com
        type:
          type: string
          example: application/vnd.dwolla.v1.hal+json
        resource-type:
          type: string
          example: resource-type
    Event:
      title: Event
      type: object
      properties:
        _links:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/HalLink'
        id:
          type: string
          example: 81f6e13c-557c-4449-9331-da5c65e61095
        created:
          type: string
          format: date-time
          example: '2015-10-16T15:37:02.000Z'
        topic:
          type: string
          example: customer_transfer_created
        resourceId:
          type: string
          example: 09A166BC-1B74-E511-80DB-0AA34A9B2388
  securitySchemes:
    clientCredentials:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: /token
          x-speakeasy-token-endpoint-authentication: client_secret_basic
          scopes: {}

````